searchNodes=[{"ref":"LogicSim.html","title":"LogicSim","module":"LogicSim","type":"module","doc":"LogicSim allows you to create logic circuits comprised of nodes such as switches, lightbulbs, and logic gates. See LogicSim.Node for details on creating and managing nodes."},{"ref":"LogicSim.Node.html","title":"LogicSim.Node","module":"LogicSim.Node","type":"behaviour","doc":"A node is the basic building block of LogicSim. A node is a GenServer that has 0 or more inputs, and 0 or more outputs. Each node keeps track of which nodes are connected to each of its outputs. When an output changes the node sends a message to its connected nodes telling them what value to set on the input they are conneted to. Nodes are modules that use LogicSim.Node as demonstrated below, optionally specifying a list of inputs, a list of outputs, and/or a map with additional state: defmodule LogicSim.Node.Or do use LogicSim.Node, inputs: [:a, :b], outputs: [:a] defmodule LogicSim.Node.OnOffSwitch do use LogicSim.Node, outputs: [:a], additional_state: %{on: false} and implement the callback calculate_outputs/2 to generate all output values given the current input values as demonstrated here (the Not gate): def calculate_outputs(_state, %{a: a} = _input_values) do %{a: !a} end"},{"ref":"LogicSim.Node.html#c:calculate_outputs/2","title":"LogicSim.Node.calculate_outputs/2","module":"LogicSim.Node","type":"callback","doc":""},{"ref":"LogicSim.Node.html#get_state/1","title":"LogicSim.Node.get_state/1","module":"LogicSim.Node","type":"function","doc":""},{"ref":"LogicSim.Node.html#link_output_to_node/4","title":"LogicSim.Node.link_output_to_node/4","module":"LogicSim.Node","type":"function","doc":"Generic version of function that allows linking of two nodes without having to know or call the specific node type&#39;s version."},{"ref":"LogicSim.Node.And.html","title":"LogicSim.Node.And","module":"LogicSim.Node.And","type":"module","doc":"Simple and logic gate. Two inputs, output is true if both inputs are true, false otherwise."},{"ref":"LogicSim.Node.And.html#calculate_outputs/2","title":"LogicSim.Node.And.calculate_outputs/2","module":"LogicSim.Node.And","type":"function","doc":"Callback implementation for LogicSim.Node.calculate_outputs/2."},{"ref":"LogicSim.Node.And.html#get_state/1","title":"LogicSim.Node.And.get_state/1","module":"LogicSim.Node.And","type":"function","doc":"Returns state of server. Also can be called from LogicSim.Node.get_state if you don&#39;t know the node type."},{"ref":"LogicSim.Node.And.html#link_output_to_node/4","title":"LogicSim.Node.And.link_output_to_node/4","module":"LogicSim.Node.And","type":"function","doc":"Links this nodes output to the input of another node. Takes the output node, the output to attach from, the node to attach to, and the node&#39;s input to attach to."},{"ref":"LogicSim.Node.And.html#set_node_input/3","title":"LogicSim.Node.And.set_node_input/3","module":"LogicSim.Node.And","type":"function","doc":"Tells this node to set its input to the given value Will be called by another node when its output is changed while linked to this input."},{"ref":"LogicSim.Node.And.html#start_link/1","title":"LogicSim.Node.And.start_link/1","module":"LogicSim.Node.And","type":"function","doc":"Starts the node with the given options Possible Options: listeners: a list of process pids that should be notified whenever the state of the node changes. Listener will receive {:logic_sim_node_state, this_nodes_pid, this_nodes_state}"},{"ref":"LogicSim.Node.And.html#start_link!/1","title":"LogicSim.Node.And.start_link!/1","module":"LogicSim.Node.And","type":"function","doc":"Same as start_link/1 but raises on error."},{"ref":"LogicSim.Node.Lightbulb.html","title":"LogicSim.Node.Lightbulb","module":"LogicSim.Node.Lightbulb","type":"module","doc":"Simple lightbulb representation. Has one input and no outputs."},{"ref":"LogicSim.Node.Lightbulb.html#calculate_outputs/2","title":"LogicSim.Node.Lightbulb.calculate_outputs/2","module":"LogicSim.Node.Lightbulb","type":"function","doc":"Callback implementation for LogicSim.Node.calculate_outputs/2."},{"ref":"LogicSim.Node.Lightbulb.html#get_state/1","title":"LogicSim.Node.Lightbulb.get_state/1","module":"LogicSim.Node.Lightbulb","type":"function","doc":"Returns state of server. Also can be called from LogicSim.Node.get_state if you don&#39;t know the node type."},{"ref":"LogicSim.Node.Lightbulb.html#link_output_to_node/4","title":"LogicSim.Node.Lightbulb.link_output_to_node/4","module":"LogicSim.Node.Lightbulb","type":"function","doc":"Links this nodes output to the input of another node. Takes the output node, the output to attach from, the node to attach to, and the node&#39;s input to attach to."},{"ref":"LogicSim.Node.Lightbulb.html#set_node_input/3","title":"LogicSim.Node.Lightbulb.set_node_input/3","module":"LogicSim.Node.Lightbulb","type":"function","doc":"Tells this node to set its input to the given value Will be called by another node when its output is changed while linked to this input."},{"ref":"LogicSim.Node.Lightbulb.html#start_link/1","title":"LogicSim.Node.Lightbulb.start_link/1","module":"LogicSim.Node.Lightbulb","type":"function","doc":"Starts the node with the given options Possible Options: listeners: a list of process pids that should be notified whenever the state of the node changes. Listener will receive {:logic_sim_node_state, this_nodes_pid, this_nodes_state}"},{"ref":"LogicSim.Node.Lightbulb.html#start_link!/1","title":"LogicSim.Node.Lightbulb.start_link!/1","module":"LogicSim.Node.Lightbulb","type":"function","doc":"Same as start_link/1 but raises on error."},{"ref":"LogicSim.Node.Not.html","title":"LogicSim.Node.Not","module":"LogicSim.Node.Not","type":"module","doc":"Simple not logic gate. One input and one output. Output is opposite of input."},{"ref":"LogicSim.Node.Not.html#calculate_outputs/2","title":"LogicSim.Node.Not.calculate_outputs/2","module":"LogicSim.Node.Not","type":"function","doc":"Callback implementation for LogicSim.Node.calculate_outputs/2."},{"ref":"LogicSim.Node.Not.html#get_state/1","title":"LogicSim.Node.Not.get_state/1","module":"LogicSim.Node.Not","type":"function","doc":"Returns state of server. Also can be called from LogicSim.Node.get_state if you don&#39;t know the node type."},{"ref":"LogicSim.Node.Not.html#link_output_to_node/4","title":"LogicSim.Node.Not.link_output_to_node/4","module":"LogicSim.Node.Not","type":"function","doc":"Links this nodes output to the input of another node. Takes the output node, the output to attach from, the node to attach to, and the node&#39;s input to attach to."},{"ref":"LogicSim.Node.Not.html#set_node_input/3","title":"LogicSim.Node.Not.set_node_input/3","module":"LogicSim.Node.Not","type":"function","doc":"Tells this node to set its input to the given value Will be called by another node when its output is changed while linked to this input."},{"ref":"LogicSim.Node.Not.html#start_link/1","title":"LogicSim.Node.Not.start_link/1","module":"LogicSim.Node.Not","type":"function","doc":"Starts the node with the given options Possible Options: listeners: a list of process pids that should be notified whenever the state of the node changes. Listener will receive {:logic_sim_node_state, this_nodes_pid, this_nodes_state}"},{"ref":"LogicSim.Node.Not.html#start_link!/1","title":"LogicSim.Node.Not.start_link!/1","module":"LogicSim.Node.Not","type":"function","doc":"Same as start_link/1 but raises on error."},{"ref":"LogicSim.Node.OnOffSwitch.html","title":"LogicSim.Node.OnOffSwitch","module":"LogicSim.Node.OnOffSwitch","type":"module","doc":"On/Off switch representation. No inputs, one output. Remembers current state and can be toggled, which inverts its output."},{"ref":"LogicSim.Node.OnOffSwitch.html#calculate_outputs/2","title":"LogicSim.Node.OnOffSwitch.calculate_outputs/2","module":"LogicSim.Node.OnOffSwitch","type":"function","doc":"Callback implementation for LogicSim.Node.calculate_outputs/2."},{"ref":"LogicSim.Node.OnOffSwitch.html#get_state/1","title":"LogicSim.Node.OnOffSwitch.get_state/1","module":"LogicSim.Node.OnOffSwitch","type":"function","doc":"Returns state of server. Also can be called from LogicSim.Node.get_state if you don&#39;t know the node type."},{"ref":"LogicSim.Node.OnOffSwitch.html#link_output_to_node/4","title":"LogicSim.Node.OnOffSwitch.link_output_to_node/4","module":"LogicSim.Node.OnOffSwitch","type":"function","doc":"Links this nodes output to the input of another node. Takes the output node, the output to attach from, the node to attach to, and the node&#39;s input to attach to."},{"ref":"LogicSim.Node.OnOffSwitch.html#set_node_input/3","title":"LogicSim.Node.OnOffSwitch.set_node_input/3","module":"LogicSim.Node.OnOffSwitch","type":"function","doc":"Tells this node to set its input to the given value Will be called by another node when its output is changed while linked to this input."},{"ref":"LogicSim.Node.OnOffSwitch.html#start_link/1","title":"LogicSim.Node.OnOffSwitch.start_link/1","module":"LogicSim.Node.OnOffSwitch","type":"function","doc":"Starts the node with the given options Possible Options: listeners: a list of process pids that should be notified whenever the state of the node changes. Listener will receive {:logic_sim_node_state, this_nodes_pid, this_nodes_state}"},{"ref":"LogicSim.Node.OnOffSwitch.html#start_link!/1","title":"LogicSim.Node.OnOffSwitch.start_link!/1","module":"LogicSim.Node.OnOffSwitch","type":"function","doc":"Same as start_link/1 but raises on error."},{"ref":"LogicSim.Node.OnOffSwitch.html#toggle/1","title":"LogicSim.Node.OnOffSwitch.toggle/1","module":"LogicSim.Node.OnOffSwitch","type":"function","doc":""},{"ref":"LogicSim.Node.Or.html","title":"LogicSim.Node.Or","module":"LogicSim.Node.Or","type":"module","doc":"Simple or logic gate. Two inputs, one output. Output is true if either (or both) inputs are true."},{"ref":"LogicSim.Node.Or.html#calculate_outputs/2","title":"LogicSim.Node.Or.calculate_outputs/2","module":"LogicSim.Node.Or","type":"function","doc":"Callback implementation for LogicSim.Node.calculate_outputs/2."},{"ref":"LogicSim.Node.Or.html#get_state/1","title":"LogicSim.Node.Or.get_state/1","module":"LogicSim.Node.Or","type":"function","doc":"Returns state of server. Also can be called from LogicSim.Node.get_state if you don&#39;t know the node type."},{"ref":"LogicSim.Node.Or.html#link_output_to_node/4","title":"LogicSim.Node.Or.link_output_to_node/4","module":"LogicSim.Node.Or","type":"function","doc":"Links this nodes output to the input of another node. Takes the output node, the output to attach from, the node to attach to, and the node&#39;s input to attach to."},{"ref":"LogicSim.Node.Or.html#set_node_input/3","title":"LogicSim.Node.Or.set_node_input/3","module":"LogicSim.Node.Or","type":"function","doc":"Tells this node to set its input to the given value Will be called by another node when its output is changed while linked to this input."},{"ref":"LogicSim.Node.Or.html#start_link/1","title":"LogicSim.Node.Or.start_link/1","module":"LogicSim.Node.Or","type":"function","doc":"Starts the node with the given options Possible Options: listeners: a list of process pids that should be notified whenever the state of the node changes. Listener will receive {:logic_sim_node_state, this_nodes_pid, this_nodes_state}"},{"ref":"LogicSim.Node.Or.html#start_link!/1","title":"LogicSim.Node.Or.start_link!/1","module":"LogicSim.Node.Or","type":"function","doc":"Same as start_link/1 but raises on error."}]